
#ifndef const_cuh
#define const_cuh


#define warp_size 32
#define db_sol_cut_off_const 100
#define max_block_size_multiplier 1.3
#define nlp_max_res 0.0001
#define nlp_max_block_cnt 20

#define dbl_comp_equal_margin 0.000000001

#define nlp_search_equal_coeff_start_rate 0.1
#define nlp_search_equal_coeff_stop_margin 0.00001
#define nlp_search_equal_coeff_rate_delta 0.5

#define linear_eq_lmt 33


// iter

#define iter_use_max 0
#define iter_use_last 1
#define iter_use_factor 2


// nlp loop

#define nlp_loop_work_blocks_per_krnl 192
#define nlp_loop_stream_cnt 5
#define nlp_dist_comb_cases_per_block_const 8


// nlp comp loop

#define base_dir 3
#define nlp_comp_loop_work_stack_lmt 20000
#define nlp_comp_loop_work_blocks_per_krnl 192
#define nlp_comp_loop_stream_cnt 5
#define nlp_comp_loop_stream_row_mul 3
#define nlp_comp_loop_krnls_to_process 1


// comp spline loop

#define base_dir 3
#define nlp_comp_spline_work_stack_lmt 20000
#define nlp_comp_spline_work_blocks_per_krnl 192
#define nlp_comp_spline_stream_cnt 5
#define nlp_comp_spline_stream_row_mul 3
#define nlp_comp_spline_krnls_to_process 1


// jacobian spline

#define nlp_jac_spline_coeff_delta_margin_low 0.1
#define nlp_jac_spline_coeff_delta_margin_upr 0.2
#define nlp_jac_spline_comp_coeff_delta_margin_const 0.0001

#define nlp_jac_indr_iss_lmt_to_imm_block 0
#define nlp_jac_search_coeff_delta 1
#define nlp_jac_post_process_coeff_delta 1
#define nlp_jac_coeff_max_step_incr 0.001
#define nlp_jac_coeff_search_max_incr 0.1
#define nlp_jac_coeff_search_min_incr 0.0001


// nlp pnt

#define nlp_pnt_stream_cnt 5
#define nlp_pnt_cases_per_krnl 128
#define nlp_pnt_dist_comb_cases_per_block_const 4


// nlp pnt jac

#define nlp_pnt_jac_lmt_iss_res 0
#define nlp_pnt_jac_stream_cnt 5
#define nlp_pnt_jac_cases_per_krnl 128
#define nlp_pnt_jac_dist_comb_cases_per_block_const 4

#define nlp_pnt_jac_max_coeff_step_incr 0.001
#define nlp_iss_res_lmt_const 0.5


// directions; no direction must be = 0

#define nlp_no_dir 0 // must be = 0
#define nlp_up_dir 1
#define nlp_down_dir 2
#define nlp_any_dir 3 // must be = 3 - the highest number of all directions


// block sizes

#define nlp_mul_comb_block_size 256
#define nlp_mul_comb_no_df_adj_block_size 256
#define nlp_mul_comb_iss_res_block_size 256

#define nlp_block_time_diff_rec_block_size 128
#define nlp_init_port_pnt_time_diff_block_size 256
#define nlp_iss_uni_fwd_block_size 256
#define nlp_dist_comb_block_size 128
#define nlp_expand_coeff_block_size 32
#define nlp_upd_comb_block_size 128
#define nlp_extract_coeff_block_size 32
#define nlp_expand_all_coeff_block_size 32
#define nlp_pnt_to_block_map_block_size 512
#define nlp_block_last_pnt_time_block_size 32
#define nlp_expand_out_coeff_A_block_size 32
#define nlp_expand_out_coeff_B_block_size 512
#define nlp_expand_out_coeff_C_block_size 512

#define nlp_block_time_diff_rec_w_exp_block_size 32
#define nlp_block_time_diff_rec_pair_sum_block_size 32
#define nlp_calc_spline_base_var_block_size 32
#define nlp_block_coeff_spline_factor_pair_sum_block_size 32
#define nlp_rotate_spline_coeff_block_size 32
#define nlp_calc_spline_coeff_block_size 32
#define nlp_rotate_spline_coeff_back_block_size 32
#define nlp_calc_spline_block_size 32

#define nlp_iss_var_lmt_iss_res_block_size 64
#define nlp_iss_var_mul_iss_res_block_size 32
#define nlp_transpose_matrix_block_size 32
#define nlp_matrix_mul_transpose_block_size 32
#define nlp_matrix_mul_transpose_big_block_size 64
#define nlp_linear_eq_block_size 32
#define nlp_linear_eq_big_block_size 256
#define nlp_jac_spline_process_new_coeff_block_size 128

#define nlp_mul_iss_block_size 32

#define nlp_distr_and_adj_comb_block_size 128
#define nlp_exp_comb_block_size 128
#define nlp_compare_mul_sum_block_size 128


// iss uni fwd

#define nlp_iss_uni_fwd_int_data_length 1
#define nlp_iss_uni_fwd_dbl_data_length 3
#define nlp_iss_uni_fwd_int_ptr_length 2
#define nlp_iss_uni_fwd_dbl_ptr_length 5

#define nlp_iss_uni_fwd_post_comb 0

#define nlp_iss_uni_fwd_start_rate 0
#define nlp_iss_uni_fwd_margin 1
#define nlp_iss_uni_fwd_rate_delta 2

#define nlp_uni_fwd_iss_pnts_n 0
#define nlp_uni_fwd_sum_iss_pnts_n 1

#define nlp_iss_uni_fwd_iss_val 0
#define nlp_iss_uni_fwd_iss_time_diff 1
#define nlp_iss_uni_fwd_iss_cpn 2
#define nlp_iss_uni_fwd_iss_out_rate 3
#define nlp_iss_uni_fwd_out_comb 4


// dist comb

#define nlp_dist_comb_int_data_length 4
#define nlp_dist_comb_dbl_ptr_length 2

#define nlp_dist_in_comb_pnt_cnt 0
#define nlp_dist_comb_in_cases_per_block 1
#define nlp_dist_comb_in_comb_offset 2
#define nlp_dist_comb_in_case_cnt 3

#define nlp_dist_comb_in_comb 0
#define nlp_dist_comb_out_comb 1


// expand coefficients

#define nlp_expand_coeff_int_data_offset_fixed 32
#define nlp_expand_coeff_dbl_data_offset_fixed 32
#define nlp_expand_coeff_int_data_length 4
#define nlp_expand_coeff_dbl_data_length 7
#define nlp_expand_coeff_dbl_ptr_length 5

#define nlp_expand_coeff_block_pnt_cnt 0
#define nlp_expand_coeff_block_pnt_start 1
#define nlp_expand_coeff_in_comb_offset 3

#define nlp_expand_coeff_block_fwd 0
#define nlp_expand_coeff_block_time_diff_rec 3
#define nlp_expand_coeff_block_start_time 5

#define nlp_expand_coeff_in_comb 0
#define nlp_expand_coeff_in_port_time 1
#define nlp_expand_coeff_in_port_time_diff 2
#define nlp_expand_coeff_out_comb 3
#define nlp_expand_coeff_out_df_adjust 4


// mul comb

#define nlp_mul_comb_int_data_offset_fixed 32
#define nlp_mul_comb_int_data_length 4
#define nlp_mul_comb_int_ptr_length 3
#define nlp_mul_comb_dbl_ptr_length 5

#define nlp_mul_comb_mul_block_cnt 0
#define nlp_mul_comb_iss_pnt_cnt 1
#define nlp_mul_comb_df_adjust_start 2
#define nlp_mul_comb_in_comb_offset 3

#define nlp_mul_comb_mul_block_iss_cnt 0
#define nlp_mul_comb_block_iss_adj_port_pnt 1
#define nlp_mul_comb_block_iss_stop 2

#define nlp_mul_comb_in_df_adjust 0
#define nlp_mul_comb_block_iss_cpn 1
#define nlp_mul_comb_in_comb 2
#define nlp_mul_comb_block_iss_val 3
#define nlp_mul_comb_out_mul_sum 4


// expand all coefficients

#define nlp_expand_all_coeff_int_data_length 4
#define nlp_expand_all_coeff_int_ptr_length 1
#define nlp_expand_all_coeff_dbl_ptr_length 6

#define nlp_expand_all_coeff_in_block_cnt 0
#define nlp_expand_all_coeff_in_pnt_cnt 1
#define nlp_expand_all_coeff_in_comb_offset 2
#define nlp_expand_all_coeff_in_coeff_offset 3

#define nlp_expand_all_coeff_in_pnt_to_block_map 0

#define nlp_expand_all_coeff_in_coeff 0
#define nlp_expand_all_coeff_in_block_time_diff_rec 1
#define nlp_expand_all_coeff_in_block_last_pnt_time 2
#define nlp_expand_all_coeff_in_port_time 3
#define nlp_expand_all_coeff_in_port_time_diff 4
#define nlp_expand_all_coeff_out_comb 5


// mul comb no df adj

#define nlp_mul_comb_no_df_adj_int_data_length 3
#define nlp_mul_comb_no_df_adj_int_ptr_length 3
#define nlp_mul_comb_no_df_adj_dbl_ptr_length 4

#define nlp_mul_comb_no_df_adj_mul_block_cnt 0
#define nlp_mul_comb_no_df_adj_iss_pnt_cnt 1
#define nlp_mul_comb_no_df_adj_comb_offset 2

#define nlp_mul_comb_no_df_adj_mul_block_iss_cnt 0
#define nlp_mul_comb_no_df_adj_block_iss_adj_port_pnt 1
#define nlp_mul_comb_no_df_adj_block_iss_stop 2

#define nlp_mul_comb_no_df_adj_block_iss_cpn 0
#define nlp_mul_comb_no_df_adj_in_comb 1
#define nlp_mul_comb_no_df_adj_block_iss_val 2
#define nlp_mul_comb_no_df_adj_out_mul_sum 3


// calc spline base variables

#define nlp_calc_spline_base_var_int_data_length 4
#define nlp_calc_spline_base_var_dbl_ptr_length 6

#define nlp_calc_spline_base_var_in_coeff_pair_cnt 0
#define nlp_calc_spline_base_var_in_coeff_offset 1
#define nlp_calc_spline_base_var_in_coeff_pair_offset 2
#define nlp_calc_spline_base_var_in_coeff_pair_cnt_min1 3

#define nlp_calc_spline_base_var_in_coeff 0
#define nlp_calc_spline_base_var_in_coeff_time_diff_rec_pow2 1
#define nlp_calc_spline_base_var_out_coeff_delta 2
#define nlp_calc_spline_base_var_out_coeff_delta_prod 3
#define nlp_calc_spline_base_var_out_coeff_delta_prod_1st 4
#define nlp_calc_spline_base_var_out_coeff_delta_prod_last 5


// calc coeff_spline_factor_pair_sum

#define nlp_block_coeff_spline_factor_pair_sum_int_data_length 3
#define nlp_block_coeff_spline_factor_pair_sum_dbl_ptr_length 2

#define nlp_block_coeff_spline_factor_pair_sum_in_pair_cnt 0
#define nlp_block_coeff_spline_factor_pair_sum_in_coeff_offset 1
#define nlp_block_coeff_spline_factor_pair_sum_in_coeff_pair_offset 2

#define nlp_block_coeff_spline_factor_pair_sum_in_coeff_delta_prod 0
#define nlp_block_coeff_spline_factor_pair_sum_out_coeff_delta_prod_pair_sum 1


// rotate_spline_coeff

#define nlp_rotate_spline_coeff_int_data_length 5
#define nlp_rotate_spline_coeff_dbl_ptr_length 2

#define nlp_rotate_spline_coeff_in_coeff_cnt 0
#define nlp_rotate_spline_coeff_in_coeff_pair_cnt 1
#define nlp_rotate_spline_coeff_in_coeff_offset 2
#define nlp_rotate_spline_coeff_in_coeff_cases_cnt 3
#define nlp_rotate_spline_coeff_in_prim_blockdim 4

#define nlp_rotate_spline_coeff_in_coeff_arr 0
#define nlp_rotate_spline_coeff_out_coeff_arr 1


// calc spline coeff

#define nlp_calc_spline_coeff_const_fact_length 4
#define nlp_calc_spline_coeff_int_data_length 4
#define nlp_calc_spline_coeff_dbl_ptr_length 9

#define nlp_calc_spline_coeff_in_coeff_cnt 0
#define nlp_calc_spline_coeff_in_set_cnt 1
#define nlp_calc_spline_coeff_in_interval_cnt 2
#define nlp_calc_spline_coeff_in_coeff_cnt_min2 3

#define nlp_calc_spline_coeff_in_const_fact 0
#define nlp_calc_spline_coeff_in_time_diff_rec 1
#define nlp_calc_spline_coeff_in_time_diff_rec_pair_sum 2
#define nlp_calc_spline_coeff_in_coeff_delta_prod_1st 3
#define nlp_calc_spline_coeff_in_coeff_delta_prod_last 4
#define nlp_calc_spline_coeff_in_coeff_delta_prod 5
#define nlp_calc_spline_coeff_out_resultA 6
#define nlp_calc_spline_coeff_out_resultB 7
#define nlp_calc_spline_coeff_out_coeff 8


// rotate spline coeff back

#define nlp_rotate_spline_coeff_back_int_data_length 4
#define nlp_rotate_spline_coeff_back_dbl_ptr_length 2

#define nlp_rotate_spline_coeff_back_in_coeff_cnt 0
#define nlp_rotate_spline_coeff_back_in_case_cnt 1
#define nlp_rotate_spline_coeff_back_in_coeff_offset 2
#define nlp_rotate_spline_coeff_back_in_prim_blockdim 3

#define nlp_rotate_spline_coeff_back_in_arr 0
#define nlp_rotate_spline_coeff_back_out_arr 1


// calc spline

#define nlp_calc_spline_int_data_length 4
#define nlp_calc_spline_int_ptr_length 1
#define nlp_calc_spline_dbl_ptr_length 7

#define nlp_calc_spline_in_knot_cnt 0
#define nlp_calc_spline_in_comb_pnt_cnt 1
#define nlp_calc_spline_in_coeff_offset 2
#define nlp_calc_spline_in_comb_offset 3

#define nlp_calc_spline_in_pnt_block_map 0

#define nlp_calc_spline_in_fwd_coeff 0
#define nlp_calc_spline_in_coeff_time 1
#define nlp_calc_spline_in_coeff_time_diff_rec 2
#define nlp_calc_spline_in_spline_coeff 3
#define nlp_calc_spline_in_pnt_time 4
#define nlp_calc_spline_in_pnt_time_diff 5
#define nlp_calc_spline_out_comb 6


// mul iss

#define nlp_mul_iss_int_data_offset_fixed 32
#define nlp_mul_iss_int_data_length 4
#define nlp_mul_iss_int_ptr_length 1
#define nlp_mul_iss_dbl_ptr_length 3

#define nlp_mul_iss_in_iss_pnt_cnt 0
#define nlp_mul_iss_in_iss_pnt_offset 1
#define nlp_mul_iss_in_iss_comb_offset 2
#define nlp_mul_iss_out_mul_sum_adr 3

#define nlp_mul_iss_in_iss_port_pnt 0

#define nlp_mul_iss_in_iss_cpn 0
#define nlp_mul_iss_in_comb 1
#define nlp_mul_iss_out_mul_sum 2


// mul comb iss res

#define nlp_mul_comb_iss_res_int_data_length 4
#define nlp_mul_comb_iss_res_int_ptr_length 3
#define nlp_mul_comb_iss_res_dbl_ptr_length 6

#define nlp_mul_comb_iss_res_mul_block_cnt 0
#define nlp_mul_comb_iss_res_iss_pnt_cnt 1
#define nlp_mul_comb_iss_res_comb_offset 2
#define nlp_mul_comb_iss_res_iss_offset 3

#define nlp_mul_comb_iss_res_mul_block_iss_cnt 0
#define nlp_mul_comb_iss_res_block_iss_adj_port_pnt 1
#define nlp_mul_comb_iss_res_block_iss_stop 2

#define nlp_mul_comb_iss_res_block_iss_cpn 0
#define nlp_mul_comb_iss_res_in_comb 1
#define nlp_mul_comb_iss_res_block_iss_val 2
#define nlp_mul_comb_iss_res_out_mul_sum 3
#define nlp_mul_comb_iss_res_out_iss_res 4
#define nlp_mul_comb_iss_res_out_iss_mul_sum 5


// iss_var_lmt_iss_res

#define nlp_iss_var_lmt_iss_res_int_data_length 1
#define nlp_iss_var_lmt_iss_res_dbl_data_length 1
#define nlp_iss_var_lmt_iss_res_dbl_ptr_length 2

#define nlp_iss_var_lmt_iss_res_in_iss_cnt 0

#define nlp_iss_var_lmt_iss_res_in_max_res 0

#define nlp_iss_var_lmt_iss_res_in_iss_res 0
#define nlp_iss_var_lmt_iss_res_out_iss_res 1


// iss_var_mul_iss_res

#define nlp_iss_var_mul_iss_res_int_data_length 5
#define nlp_iss_var_mul_iss_res_dbl_ptr_length 7

#define nlp_iss_var_mul_iss_res_iss_cnt 0
#define nlp_iss_var_mul_iss_res_iss_offset 1
#define nlp_iss_var_mul_iss_res_in_matrix_row_offset 2
#define nlp_iss_var_mul_iss_res_in_matrix_min_dep_row_cnt 3
#define nlp_iss_var_mul_iss_res_in_search_coeff_delta 4

#define nlp_iss_var_mul_iss_res_in_delta_f_val 0
#define nlp_iss_var_mul_iss_res_in_delta_f_base 1
#define nlp_iss_var_mul_iss_res_in_delta_coeff 2
#define nlp_iss_var_mul_iss_res_in_delta_coeff_base 3
#define nlp_iss_var_mul_iss_res_in_iss_res 4
#define nlp_iss_var_mul_iss_res_out_delta_coeff_iss_var 5
#define nlp_iss_var_mul_iss_res_out_matrix_dep_var 6


// transpose_matrix

#define nlp_transpose_matrix_int_data_length 4
#define nlp_transpose_matrix_dbl_ptr_length 2

#define nlp_transpose_matrix_in_col_cnt 0
#define nlp_transpose_matrix_in_row_cnt 1
#define nlp_transpose_matrix_in_col_offset 2
#define nlp_transpose_matrix_in_row_offset 3

#define nlp_transpose_matrix_in_matrix 0
#define nlp_transpose_matrix_out_matrix 1


// matrix_mul_transpose

#define nlp_matrix_mul_transpose_int_data_length 6
#define nlp_matrix_mul_transpose_dbl_ptr_length 2

#define nlp_matrix_mul_transpose_in_col_cnt 0
#define nlp_matrix_mul_transpose_in_row_cnt 1
#define nlp_matrix_mul_transpose_in_row_offset 2
#define nlp_matrix_mul_transpose_out_row_offset 3
#define nlp_matrix_mul_transpose_in_rows_per_block 4
#define nlp_matrix_mul_transpose_in_col_cnt_min1 5

#define nlp_matrix_mul_transpose_in_matrix 0
#define nlp_matrix_mul_transpose_out_matrix 1


// matrix_mul_transpose_big

#define nlp_matrix_mul_transpose_big_int_data_length 5
#define nlp_matrix_mul_transpose_big_dbl_ptr_length 2

#define nlp_matrix_mul_transpose_big_in_rows_per_block 0
#define nlp_matrix_mul_transpose_big_in_col_cnt 1
#define nlp_matrix_mul_transpose_big_in_row_cnt 2
#define nlp_matrix_mul_transpose_big_in_row_offset 3
#define nlp_matrix_mul_transpose_big_out_row_offset 4

#define nlp_matrix_mul_transpose_big_in_matrix 0
#define nlp_matrix_mul_transpose_big_out_matrix 1


// linear_eq

#define nlp_linear_eq_int_data_length 5
#define nlp_linear_eq_dbl_ptr_length 3

#define nlp_linear_eq_in_row_cnt 0
#define nlp_linear_eq_in_col_cnt 1
#define nlp_linear_eq_in_col_cnt_min1 2
#define nlp_linear_eq_in_row_offset 3
#define nlp_linear_eq_in_row_cnt_min1 4

#define nlp_linear_eq_in_matrix 0
#define nlp_linear_eq_out_arr 1
#define nlp_linear_eq_out_status 2


// linear_eq_big

#define nlp_linear_eq_big_int_data_length 6
#define nlp_linear_eq_big_dbl_ptr_length 5

#define nlp_linear_eq_big_in_col_cnt 0
#define nlp_linear_eq_big_in_col_cnt_min1 1
#define nlp_linear_eq_big_in_row_cnt 2
#define nlp_linear_eq_big_in_row_cnt_min1 3
#define nlp_linear_eq_big_in_row_offset 4
#define nlp_linear_eq_big_in_row_cntx2 5

#define nlp_linear_eq_big_in_matrix 0
#define nlp_linear_eq_big_out_arr 1
#define nlp_linear_eq_big_temp_out_arrA 2
#define nlp_linear_eq_big_temp_out_arrB 3
#define nlp_linear_eq_big_out_status 4


// nlp_jac_spline_process_new_coeff

#define nlp_jac_spline_process_new_coeff_dbl_ptr_length 5

#define nlp_jac_spline_process_new_coeff_in_old_coeff 0
#define nlp_jac_spline_process_new_coeff_in_coeff_delta 1
#define nlp_jac_spline_process_new_coeff_out_new_coeff 2
#define nlp_jac_spline_process_new_coeff_in_le_status 3
#define nlp_jac_spline_process_new_coeff_in_max_step_incr 4


// nlp_distr_and_adj_comb

#define nlp_distr_and_adj_comb_int_data_length 6
#define nlp_distr_and_adj_comb_dbl_data_length 1
#define nlp_distr_and_adj_comb_dbl_ptr_length 2

#define nlp_distr_and_adj_comb_in_pnt_cnt 0
#define nlp_distr_and_adj_comb_in_cases_per_block 1
#define nlp_distr_and_adj_comb_in_comb_offset 2
#define nlp_distr_and_adj_comb_in_neg_dir 3
#define nlp_distr_and_adj_comb_in_case_cnt 4
#define nlp_distr_and_adj_comb_in_cases_base 5

#define nlp_distr_and_adj_comb_in_pnt_incr 0

#define nlp_distr_and_adj_comb_in_comb 0
#define nlp_distr_and_adj_comb_out_comb 1


// exp comb

#define nlp_exp_comb_int_data_length 2
#define nlp_exp_comb_dbl_ptr_length 3

#define nlp_exp_comb_in_comb_offset 0
#define nlp_exp_comb_in_pnt_cnt 1

#define nlp_exp_comb_in_pnt_time_diff 0
#define nlp_exp_comb_in_comb 1
#define nlp_exp_comb_out_comb 2


// nlp_compare_mul_sum

#define nlp_compare_mul_sum_int_data_length 1
#define nlp_compare_mul_sum_int_ptr_length 1
#define nlp_compare_mul_sum_dbl_ptr_length 2

#define nlp_compare_mul_sum_in_case_cnt 0

#define nlp_compare_mul_sum_out_best_case_n 0

#define nlp_compare_mul_sum_in_mul_sum 0
#define nlp_compare_mul_sum_out_best_case 1


#endif
