
#ifndef data_cuh
#define data_cuh


#include "main_d.cuh"


struct NLP_extract_coeff
{
	int* h_coeff_block_start;

	double* h_coeff_time_diff;

	int* d_coeff_block_start;

	double* d_coeff;
	double* d_coeff_time_diff;

	int* h_nlp_expand_all_coeff_int_data;
	int** h_nlp_expand_all_coeff_int_ptr;
	double** h_nlp_expand_all_coeff_dbl_ptr;

	int* d_nlp_expand_all_coeff_int_data;
	int** d_nlp_expand_all_coeff_int_ptr;
	double** d_nlp_expand_all_coeff_dbl_ptr;
};


struct NLP_host_expand_spline_sol
{
	int* h_nlp_calc_spline_int_data;
	int** h_nlp_calc_spline_int_ptr;
	double** h_nlp_calc_spline_dbl_ptr;

	int* d_nlp_calc_spline_int_data;
	int** d_nlp_calc_spline_int_ptr;
	double** d_nlp_calc_spline_dbl_ptr;

	double* h_spline_coeff;
	double* h_spline_sol_coeff;
	double* h_spline_out_comb;

	double* d_spline_sol_fwd_coeff;
	double* d_spline_sol_coeff;
	double* d_calc_spline_out_comb;
};


struct NLP_spline_sol
{
	int* h_nlp_calc_spline_int_data;
	int** h_nlp_calc_spline_int_ptr;
	double** h_nlp_calc_spline_dbl_ptr;

	int* d_nlp_calc_spline_int_data;
	int** d_nlp_calc_spline_int_ptr;
	double** d_nlp_calc_spline_dbl_ptr;

	double* h_spline_sol_coeff;

	double* d_spline_sol_fwd_coeff;
	double* d_spline_sol_coeff;
	double* d_calc_spline_out_comb;

	int* h_nlp_jac_calc_spline_int_data;
	int** h_nlp_jac_calc_spline_int_ptr;
	double** h_nlp_jac_calc_spline_dbl_ptr;

	int* d_nlp_jac_calc_spline_int_data;
	int** d_nlp_jac_calc_spline_int_ptr;
	double** d_nlp_jac_calc_spline_dbl_ptr;

	double* h_jac_spline_sol_coeff;

	double* d_jac_spline_sol_fwd_coeff;
	double* d_jac_spline_sol_coeff;
	double* d_jac_calc_spline_out_comb;
};


struct NLP_pnt_sol
{
	int* h_nlp_pnt_exp_comb_int_data;
	double** h_nlp_pnt_exp_comb_dbl_ptr;

	int* d_nlp_pnt_exp_comb_int_data;
	double** d_nlp_pnt_exp_comb_dbl_ptr;

	int* h_nlp_pnt_jac_exp_comb_int_data;
	double** h_nlp_pnt_jac_exp_comb_dbl_ptr;

	int* d_nlp_pnt_jac_exp_comb_int_data;
	double** d_nlp_pnt_jac_exp_comb_dbl_ptr;
};


struct NLP_init_coeff_data
{
	double* h_port_uni_fwd;

	int* h_nlp_iss_uni_fwd_int_data;
	double* h_nlp_iss_uni_fwd_dbl_data;
	int** h_nlp_iss_uni_fwd_int_ptr;
	double** h_nlp_iss_uni_fwd_dbl_ptr;

	int* d_nlp_iss_uni_fwd_int_data;
	double* d_nlp_iss_uni_fwd_dbl_data;
	int** d_nlp_iss_uni_fwd_int_ptr;
	double** d_nlp_iss_uni_fwd_dbl_ptr;

	int* d_iss_pnts_n;

	double* d_in_port_val;
	double* d_port_cpn;
	double* d_port_uni_fwd_out_rate;
};


struct NLP_data
{
	int nr_of_run_types;
	int run_comp_loop;
	int run_comp_spline;
	int run_jac_spline;
	int run_nlp_pnt;
	int run_nlp_pnt_jac;
	int comb_pnt_n;
	int init_run;
	int block_cnt;
	int coeff_cnt;
	int mul_block_size;
	int nlp_loop_mul_in_comb_first;
	int nlp_loop_found_better_case;
	int comp_loop_overflow;
	int comp_loop_had_overflow;
	int comp_loop_found_better_case;
	int comp_spline_overflow;
	int comp_spline_had_overflow;
	int comp_spline_found_better_case;
	int jac_spline_found_better_case;
	int nlp_pnt_found_better_case;
	int nlp_pnt_jac_found_better_case;

	int init_coeff_arr_created;
	int block_pnt_cnt_arr_created;
	int const_block_time_data_arr_created;
	int rerun_extract_coeff_arr_created;
	int h_coeff_arr_created;
	int comp_loop_expand_arr_created;
	int comp_spline_expand_arr_created;
	int jac_spline_expand_arr_created;
	int comp_loop_init_const_data_arr_created;
	int nlp_jac_const_block_data_arr_created;
	int nlp_jac_const_data_arr_created;
	int nlp_pnt_arr_created;
	int nlp_pnt_jac_arr_created;

	double h_result_val;
	double h_spline_result_val;
	double h_jac_spline_result_val;
	double h_nlp_pnt_result_val;
	double h_nlp_pnt_jac_result_val;
	double res;
	double h_port_uni_fwd;

	int* h_iss_sorted;
	int* exp_pnts;
	int* uni_exp_pnts;
	int* exp_block_pnt_cnt;
	int* exp_block_iss_cnt;

	int* h_block_pnt_start;
	int* h_block_pnt_cnt;
	int* h_dup_block_pnt_start;
	int* h_dup_block_pnt_cnt;

	int* h_block_exp_iss_cnt;
	int* h_block_exp_iss_excl_sum;
	int* h_block_exp_iss_n;

	int* h_iss_pnts_per_block;
	int* h_iss_pnts_per_block_excl_sum;
	int* h_mul_blocks_per_block;
	int* h_mul_blocks_per_block_excl_sum;
	int* h_block_iss_pnt_stop;
	int* h_block_adj_iss_port_pnt;
	int* h_block_mul_block_iss_cnt;

	double* h_block_iss_val;
	double* h_block_iss_cpn;

	int* d_block_adj_iss_port_pnt;
	int* d_block_iss_pnt_stop;
	int* d_block_mul_block_iss_cnt;
	double* d_block_iss_cpn;
	double* d_block_iss_val;

	double* h_coeff;
	double* h_block_time_diff;
	double* h_block_time_diff_rec;

	double* d_block_time_diff;
	double* d_block_time_diff_rec;
	double* d_port_pnt_time;
	double* d_port_pnt_time_diff;
	double* d_base_comb;

	double* d_expand_in_coeff;
	double* d_out_coeff_delta;
	double* d_out_coeff_offset;
	double* d_out_fwd;

	double* res_iter_elapsed_time;
	double* block_iter_elapsed_time;

	int* d_block_pnt_cnt;
	int* d_block_pnt_start;
	int* d_pnt_to_block_map;

	double* d_block_last_pnt_time;

	double* h_comp_run_out_comb;
	double* h_spline_out_comb;
	double* h_jac_spline_out_comb;

	double* h_spline_coeff;
	double* h_jac_spline_coeff;

	double* h_block_time;
	double* h_block_time_diff_rec_pow2;
	double* h_block_time_diff_rec_pair_sum;

	double* d_block_time;
	double* d_block_time_diff_rec_pow2;
	double* d_block_time_diff_rec_pair_sum;

	int max_indr_dir_iss_eval;
	int dir_iss_cnt;

	int* h_iss_pnt_cnt;
	int* h_iss_pnt_offset;
	int* h_jac_coeff_iss_cnt;
	int* h_jac_coeff_iss_cnt_excl_sum;
	int* h_jac_coeff_iss_n;
	int* h_jac_coeff_indr_iss_cnt;
	int* h_jac_coeff_indr_iss_cnt_excl_sum;
	int* h_jac_coeff_indr_iss_n;

	int* d_iss_offset_port_pnt;

	double* d_iss_offset_cpn;

	double* h_nlp_pnt_comb;

	double* d_nlp_pnt_base_comb;
	double* d_nlp_pnt_base_comb_used;

	double* h_nlp_pnt_jac_comb;

	double* d_nlp_pnt_jac_base_comb;

	Algo_dat* algo_dat;
	NLP_pnt_sol* nlp_pnt_sol;
};


struct NLP_loop_data
{
	int wait_on_init_mul_sum;
	int run_has_better_case;
	int found_better_case;
	int new_best_case_n;
	int new_best_case_base;
	int moving_to_new_krnl;
	int comb_pnt_n;
	int coeff_cnt;
	int coeff_cntx2;
	int rem_cnt;
	int cur_krnl_work_issued;
	int krnls_issued;

	int do_base_comb_sync;
	int coeff_ptr;
	int cur_dir;
	int coeff_dir_product;
	int last_best_coeff_dir_product;
	int cur_stream_ptr;
	int proc_stream_ptr;

	int stored_pnt_cnt;
	int stored_pnt_start;
	int stored_coeff_ptr;
	int stored_df_adj_start;

	int comb_offset;
	int work_blocks_per_krnl_offset;
	int nlp_dist_comb_pnt_blockdim;

	int nlp_dist_comb_int_data_offset;
	int nlp_dist_comb_dbl_ptr_offset;

	int nlp_expand_coeff_int_data_offset;
	int nlp_expand_coeff_dbl_data_offset;
	int nlp_expand_coeff_dbl_ptr_offset;

	int nlp_mul_comb_int_data_offset;
	int nlp_mul_comb_int_ptr_offset;
	int nlp_mul_comb_dbl_ptr_offset;

	double prev_mul_sum;
	double new_mul_sum;
	double stored_coeff;
	double stored_df_adj;

	int setup_int[4];
	double setup_dbl[7];

	int* init_block;

	int* h_nlp_dist_comb_int_data;
	double** h_nlp_dist_comb_dbl_ptr;

	int* d_nlp_dist_comb_int_data;
	double** d_nlp_dist_comb_dbl_ptr;

	int* h_nlp_expand_coeff_int_data;
	double* h_nlp_expand_coeff_dbl_data;
	double** h_nlp_expand_coeff_dbl_ptr;

	int* d_nlp_expand_coeff_int_data;
	double* d_nlp_expand_coeff_dbl_data;
	double** d_nlp_expand_coeff_dbl_ptr;

	int* h_nlp_mul_comb_int_data;
	int** h_nlp_mul_comb_int_ptr;
	double** h_nlp_mul_comb_dbl_ptr;

	int* d_nlp_mul_comb_int_data;
	int** d_nlp_mul_comb_int_ptr;
	double** d_nlp_mul_comb_dbl_ptr;

	double* d_work_block_comb;
	double* d_work_block_exit_df_adjust;
	double* d_nlp_mul_comb_out_mul_sum;

	int* krnl_work_issued;
	int* h_nlp_df_adjust_start_freeze;
	int* h_nlp_block_pnt_start_freeze;
	int* h_nlp_block_pnt_cnt_freeze;
	int* h_nlp_coeff_ptr_freeze;

	double* h_nlp_mul_comb_out_mul_sum;
	double* h_nlp_df_adjust;
	double* h_nlp_coeff_freeze;

	double* d_new_temp_base_comb;

	double* d_port_pnt_time;
	double* d_port_pnt_time_diff;

	double* h_init_mul_sum;
};


struct NLP_loop_pre_data
{
	int* h_nlp_mul_comb_int_data;
	int** h_nlp_mul_comb_int_ptr;
	double** h_nlp_mul_comb_dbl_ptr;

	int* d_nlp_mul_comb_int_data;
	int** d_nlp_mul_comb_int_ptr;
	double** d_nlp_mul_comb_dbl_ptr;

	double* d_out_mul_sum;
	double* d_in_df_adjust;
};


struct NLP_comp_loop
{
	int comb_pnt_n;
	int block_cnt;
	int coeff_cnt;
	int coeff_cntx2;
	int event_cnt;
	int work_issued;
	int krnls_issued;
	int work_ceiling;
	int stream_ptr;
	int proc_stream_ptr;
	int event_ptr;
	int work_ptr;
	int cur_krnl_work_issued;
	int cur_krnl_block_offset;
	int krnl_block_nr;
	int moving_to_new_krnl;
	int new_best_case;
	int comp_loop_overflow;
	int comp_loop_found_better_case;

	double res;
	double prev_mul_sum;

	int work_blocks_per_krnl_offset;
	int nlp_expand_all_coeff_int_data_offset;
	int nlp_expand_all_coeff_int_ptr_offset;
	int nlp_expand_all_coeff_dbl_ptr_offset;

	int nlp_mul_comb_no_df_adj_int_data_offset;
	int nlp_mul_comb_no_df_adj_int_ptr_offset;
	int nlp_mul_comb_no_df_adj_dbl_ptr_offset;

	int coeff_offset;
	int comb_offset;

	int* h_base3_exp;
	int* h_krnl_work_issued;
	int* h_init_block;

	int* h_nlp_expand_all_coeff_int_data;
	int** h_nlp_expand_all_coeff_int_ptr;
	double** h_nlp_expand_all_coeff_dbl_ptr;

	int* d_nlp_expand_all_coeff_int_data;
	int** d_nlp_expand_all_coeff_int_ptr;
	double** d_nlp_expand_all_coeff_dbl_ptr;

	int* h_nlp_mul_comb_no_df_adj_int_data;
	int** h_nlp_mul_comb_no_df_adj_int_ptr;
	double** h_nlp_mul_comb_no_df_adj_dbl_ptr;

	int* d_nlp_mul_comb_no_df_adj_int_data;
	int** d_nlp_mul_comb_no_df_adj_int_ptr;
	double** d_nlp_mul_comb_no_df_adj_dbl_ptr;

	int* h_stored_sub_coeff_cnt;
	int* h_stored_work_cnt;
	int* h_coeff_dir;

	double* h_stored_coeff;
	double* h_in_coeff;
	double* h_nlp_mul_comb_no_df_adj_out_mul_sum;

	double* d_nlp_expand_all_coeff_in_coeff;
	double* d_nlp_expand_all_coeff_out_comb;
	double* d_nlp_mul_comb_no_df_adj_out_mul_sum;
};


struct NLP_work_stack
{
	int case_cnt;

	int* work_cnt;
	int* work_ptr;
	int* sub_coeff_cnt;
	int* can_incr_div_coeff;
	int* div_coeff_is_incr;
	int* coeff_dir;

	double* coeff_set;
};


struct NLP_comp_spline
{
	int comb_pnt_n;
	int block_cnt;
	int coeff_cnt;
	int coeff_cntx2;
	int event_cnt;
	int work_issued;
	int krnls_issued;
	int work_ceiling;
	int stream_ptr;
	int proc_stream_ptr;
	int event_ptr;
	int work_ptr;
	int cur_krnl_work_issued;
	int cur_krnl_block_offset;
	int krnl_block_nr;
	int moving_to_new_krnl;
	int new_best_case;
	int comp_loop_overflow;
	int comp_loop_found_better_case;
	int push_init_coeff_case;
	int catch_init_coeff_case;

	double res;
	double prev_mul_sum;

	int nlp_calc_spline_base_var_int_data_offset;
	int nlp_calc_spline_base_var_dbl_ptr_offset;
	int nlp_block_coeff_spline_factor_pair_sum_int_data_offset;
	int nlp_block_coeff_spline_factor_pair_sum_dbl_ptr_offset;
	int nlp_rotate_spline_coeff_int_data_offset;
	int nlp_rotate_spline_coeff_dbl_ptr_offset;
	int nlp_calc_spline_coeff_int_data_offset;
	int nlp_calc_spline_coeff_dbl_ptr_offset;
	int nlp_rotate_spline_coeff_back_int_data_offset;
	int nlp_rotate_spline_coeff_back_dbl_ptr_offset;
	int nlp_calc_spline_int_data_offset;
	int nlp_calc_spline_int_ptr_offset;
	int nlp_calc_spline_dbl_ptr_offset;
	int nlp_mul_comb_no_df_adj_int_data_offset;
	int nlp_mul_comb_no_df_adj_int_ptr_offset;
	int nlp_mul_comb_no_df_adj_dbl_ptr_offset;

	int work_blocks_per_krnl_offset;
	int warp_threads_per_coeff_set;

	int nlp_rotate_spline_coeff_pnt_blockdim;
	int nlp_rotate_spline_coeff_back_pnt_blockdim;
	int nlp_calc_spline_base_var_blockdim;
	int nlp_block_coeff_spline_factor_pair_sum_blockdim;
	int calc_spline_coeff_block_offset;

	int coeff_offset;
	int comb_offset;

	int* h_base3_exp;
	int* h_krnl_work_issued;
	int* h_init_block;

	int* h_nlp_calc_spline_base_var_int_data;
	double** h_nlp_calc_spline_base_var_dbl_ptr;

	int* d_nlp_calc_spline_base_var_int_data;
	double** d_nlp_calc_spline_base_var_dbl_ptr;

	int* h_nlp_block_coeff_spline_factor_pair_sum_int_data;
	double** h_nlp_block_coeff_spline_factor_pair_sum_dbl_ptr;

	int* d_nlp_block_coeff_spline_factor_pair_sum_int_data;
	double** d_nlp_block_coeff_spline_factor_pair_sum_dbl_ptr;

	int* h_nlp_rotate_spline_coeff_int_data;
	double** h_nlp_rotate_spline_coeff_dbl_ptr;

	int* d_nlp_rotate_spline_coeff_int_data;
	double** d_nlp_rotate_spline_coeff_dbl_ptr;

	int* h_nlp_calc_spline_coeff_int_data;
	double** h_nlp_calc_spline_coeff_dbl_ptr;

	int* d_nlp_calc_spline_coeff_int_data;
	double** d_nlp_calc_spline_coeff_dbl_ptr;

	int* h_nlp_rotate_spline_coeff_back_int_data;
	double** h_nlp_rotate_spline_coeff_back_dbl_ptr;

	int* d_nlp_rotate_spline_coeff_back_int_data;
	double** d_nlp_rotate_spline_coeff_back_dbl_ptr;

	int* h_nlp_calc_spline_int_data;
	int** h_nlp_calc_spline_int_ptr;
	double** h_nlp_calc_spline_dbl_ptr;

	int* d_nlp_calc_spline_int_data;
	int** d_nlp_calc_spline_int_ptr;
	double** d_nlp_calc_spline_dbl_ptr;

	int* h_nlp_mul_comb_no_df_adj_int_data;
	int** h_nlp_mul_comb_no_df_adj_int_ptr;
	double** h_nlp_mul_comb_no_df_adj_dbl_ptr;

	int* d_nlp_mul_comb_no_df_adj_int_data;
	int** d_nlp_mul_comb_no_df_adj_int_ptr;
	double** d_nlp_mul_comb_no_df_adj_dbl_ptr;

	int* h_stored_sub_coeff_cnt;
	int* h_stored_work_cnt;
	int* h_coeff_dir;

	double* h_stored_coeff;
	double* h_in_coeff;
	double* h_nlp_mul_comb_no_df_adj_out_mul_sum;
	double* h_nlp_calc_spline_coeff_in_const_fact;

	double* d_nlp_calc_spline_base_var_in_coeff;
	double* d_spline_base_var_out_coeff_delta;
	double* d_spline_base_var_out_coeff_delta_prod;
	double* d_spline_base_var_out_coeff_delta_prod_1st;
	double* d_spline_base_var_out_coeff_delta_prod_last;
	double* d_spline_base_var_out_coeff_delta_prod_pair_sum;
	double* d_spline_base_var_rot_coeff_delta_prod_pair_sum;
	double* d_nlp_calc_spline_coeff_in_const_fact;
	double* d_nlp_calc_spline_coeff_out_resultA;
	double* d_nlp_calc_spline_coeff_out_resultB;
	double* d_nlp_calc_spline_coeff_out_coeff;
	double* d_nlp_calc_spline_coeff_rot_coeff;
	double* d_nlp_calc_spline_out_comb;
	double* d_nlp_mul_comb_no_df_adj_out_mul_sum;

	double* h_base_coeff;
	Algo_dat* algo_dat;
};


struct NLP_jac_spline
{
	int block_cnt;
	int coeff_cnt;
	int coeff_cnt_plus1;
	int comb_pnt_n;
	int issues_n;
	int first_run;
	int use_matrix_mul_transpose_big;
	int use_le_big;
	int found_better_case;
	int iss_coeff_rate_delta_found;
	int iss_coeff_rate_delta_case_cnt;
	int push_splines_init_run;
	int max_indr_dir_iss_eval;
	int dir_iss_cnt;

	int coeff_offset;
	int comb_offset;
	int iss_offset;
	int jac_matrix_row_offset;
	int nlp_mul_iss_int_data_offset;

	int nlp_matrix_mul_transpose_cases_per_block;

	int nlp_calc_spline_base_var_blockdim;
	int nlp_block_coeff_spline_factor_pair_sum_blockdim;
	int nlp_rotate_spline_coeff_pnt_blockdim;
	int nlp_rotate_spline_coeff_case_blockdim;
	int nlp_rotate_spline_coeff_back_pnt_blockdim;
	int nlp_rotate_spline_coeff_back_case_blockdim;
	int nlp_calc_spline_coeff_case_blockdim;
	int nlp_matrix_mul_transpose_case_blockdim;
	int nlp_matrix_mul_transpose_big_case_blockdim;
	int nlp_jac_spline_process_new_coeff_case_blockdim;

	double last_mul_sum;
	double coeff_incr;
	double coeff_incr_rec;
	double max_step_incr;
	double coeff_search_max_incr;
	double coeff_search_min_incr;
	double coeff_delta_margin_upr;
	double coeff_delta_margin_low;
	double coeff_delta_margin_center;
	double nlp_jac_spline_comp_coeff_delta_margin;

	int* h_nlp_calc_spline_base_var_int_data;
	double** h_nlp_calc_spline_base_var_dbl_ptr;

	int* d_nlp_calc_spline_base_var_int_data;
	double** d_nlp_calc_spline_base_var_dbl_ptr;

	int* h_nlp_block_coeff_spline_factor_pair_sum_int_data;
	double** h_nlp_block_coeff_spline_factor_pair_sum_dbl_ptr;

	int* d_nlp_block_coeff_spline_factor_pair_sum_int_data;
	double** d_nlp_block_coeff_spline_factor_pair_sum_dbl_ptr;

	int* h_nlp_rotate_spline_coeff_int_data;
	double** h_nlp_rotate_spline_coeff_dbl_ptr;

	int* d_nlp_rotate_spline_coeff_int_data;
	double** d_nlp_rotate_spline_coeff_dbl_ptr;

	int* h_nlp_calc_spline_coeff_int_data;
	double** h_nlp_calc_spline_coeff_dbl_ptr;

	int* d_nlp_calc_spline_coeff_int_data;
	double** d_nlp_calc_spline_coeff_dbl_ptr;

	int* h_nlp_rotate_spline_coeff_back_int_data;
	double** h_nlp_rotate_spline_coeff_back_dbl_ptr;

	int* d_nlp_rotate_spline_coeff_back_int_data;
	double** d_nlp_rotate_spline_coeff_back_dbl_ptr;

	int* h_nlp_calc_spline_int_data;
	int** h_nlp_calc_spline_int_ptr;
	double** h_nlp_calc_spline_dbl_ptr;

	int* d_nlp_calc_spline_int_data;
	int** d_nlp_calc_spline_int_ptr;
	double** d_nlp_calc_spline_dbl_ptr;

	int* h_nlp_mul_iss_int_data;
	int** h_nlp_mul_iss_int_ptr;
	double** h_nlp_mul_iss_dbl_ptr;

	int* d_nlp_mul_iss_int_data;
	int** d_nlp_mul_iss_int_ptr;
	double** d_nlp_mul_iss_dbl_ptr;

	int* h_nlp_mul_comb_iss_res_int_data;
	int** h_nlp_mul_comb_iss_res_int_ptr;
	double** h_nlp_mul_comb_iss_res_dbl_ptr;

	int* d_nlp_mul_comb_iss_res_int_data;
	int** d_nlp_mul_comb_iss_res_int_ptr;
	double** d_nlp_mul_comb_iss_res_dbl_ptr;

	int* h_nlp_mul_comb_indr_iss_res_int_data;
	int** h_nlp_mul_comb_indr_iss_res_int_ptr;
	double** h_nlp_mul_comb_indr_iss_res_dbl_ptr;

	int* d_nlp_mul_comb_indr_iss_res_int_data;
	int** d_nlp_mul_comb_indr_iss_res_int_ptr;
	double** d_nlp_mul_comb_indr_iss_res_dbl_ptr;

	int* h_nlp_iss_var_mul_iss_res_int_data;
	double** h_nlp_iss_var_mul_iss_res_dbl_ptr;

	int* d_nlp_iss_var_mul_iss_res_int_data;
	double** d_nlp_iss_var_mul_iss_res_dbl_ptr;

	int* h_nlp_matrix_mul_transpose_int_data;
	double** h_nlp_matrix_mul_transpose_dbl_ptr;

	int* d_nlp_matrix_mul_transpose_int_data;
	double** d_nlp_matrix_mul_transpose_dbl_ptr;

	int* h_nlp_matrix_mul_transpose_big_int_data;
	double** h_nlp_matrix_mul_transpose_big_dbl_ptr;

	int* d_nlp_matrix_mul_transpose_big_int_data;
	double** d_nlp_matrix_mul_transpose_big_dbl_ptr;

	int* h_nlp_linear_eq_int_data;
	double** h_nlp_linear_eq_dbl_ptr;

	int* d_nlp_linear_eq_int_data;
	double** d_nlp_linear_eq_dbl_ptr;

	int* h_nlp_linear_eq_big_int_data;
	double** h_nlp_linear_eq_big_dbl_ptr;

	int* d_nlp_linear_eq_big_int_data;
	double** d_nlp_linear_eq_big_dbl_ptr;

	double** h_nlp_jac_spline_process_new_coeff_dbl_ptr;

	double** d_nlp_jac_spline_process_new_coeff_dbl_ptr;

	int* h_coeff_comp_result;
	int* h_coeff_eval_status;
	int* h_coeff_eval_have_val_delta;

	double* h_work_coeff;
	double* h_next_work_coeff;
	double* h_in_coeff;
	double* h_iss_res_out_mul_sum;
	double* h_iss_res_out_iss_mul_sum;
	double* h_iss_res_out_indr_iss_mul_sum;
	double* h_coeff_eval_rate;
	double* h_coeff_eval_rate_acc;
	double* h_coeff_eval_rate_prev;
	double* h_coeff_eval_rate_last;
	double* h_coeff_eval_val_last;
	double* h_coeff_eval_val_diff_prev;
	double* h_coeff_eval_coeff_delta;
	double* h_coeff_eval_val_delta;
	double* h_le_out_status;
	double* h_nlp_calc_spline_coeff_in_const_fact;

	int* d_coeff_comp_result;

	double* d_in_base_coeff;
	double* d_in_coeff;
	double* d_spline_base_var_out_coeff_delta;
	double* d_spline_base_var_out_coeff_delta_prod;
	double* d_spline_base_var_out_coeff_delta_prod_1st;
	double* d_spline_base_var_out_coeff_delta_prod_last;
	double* d_block_coeff_spline_factor_pair_sum;
	double* d_block_coeff_spline_rot_factor_pair_sum;
	double* d_nlp_calc_spline_coeff_in_const_fact;
	double* d_calc_spline_coeff_out_resultA;
	double* d_calc_spline_coeff_out_resultB;
	double* d_calc_spline_coeff_out_coeff;
	double* d_calc_spline_coeff_rot_coeff;

	double* d_out_spline_comb;
	double* d_iss_res_out_mul_sum;
	double* d_iss_res_out_iss_res;
	double* d_iss_res_out_iss_mul_sum;
	double* d_iss_res_out_indr_mul_sum;
	double* d_iss_res_out_indr_iss_res;
	double* d_iss_res_out_indr_iss_mul_sum;

	double* d_in_iss_coeff_delta;
	double* d_nlp_jac_matrix;
	double* d_nlp_le_matrix;
	double* d_le_out_coeff_delta;
	double* d_nlp_linear_eq_big_temp_out_arrA;
	double* d_nlp_linear_eq_big_temp_out_arrB;
	double* d_le_out_status;
	double* d_nlp_jac_spline_process_new_coeff_in_max_step_incr;

	NLP_data* nlp_data;
};


struct NLP_pnt
{
	int init_run;
	int catch_init_run;
	int comb_pnt_n;
	int coeff_cnt;
	int work_rem;
	int cases_base;
	int cur_dir;
	int krnls_issued;
	int cur_stream_ptr;
	int proc_stream_ptr;
	int cur_base_comb_ptr;
	int next_base_comb_ptr;
	int wait_on_new_base_comb;
	int run_found_better_case;
	int found_better_case;

	int comb_offset;
	int cases_per_krnl_offset;
	int nlp_compare_mul_sum_offset;
	int nlp_distr_and_adj_comb_pnt_blockdim;
	int nlp_distr_and_adj_comb_int_data_offset;
	int nlp_distr_and_adj_comb_dbl_data_offset;
	int nlp_distr_and_adj_comb_dbl_ptr_offset;
	int nlp_exp_comb_int_data_offset;
	int nlp_exp_comb_dbl_ptr_offset;
	int nlp_mul_comb_no_df_adj_int_data_offset;
	int nlp_mul_comb_no_df_adj_int_ptr_offset;
	int nlp_mul_comb_no_df_adj_dbl_ptr_offset;
	int nlp_compare_mul_sum_int_data_offset;
	int nlp_compare_mul_sum_int_ptr_offset;
	int nlp_compare_mul_sum_dbl_ptr_offset;

	double res;
	double last_mul_sum;

	int* init_krnl;
	int* krnl_case_cnt;

	int* h_nlp_distr_and_adj_comb_int_data;
	double* h_nlp_distr_and_adj_comb_dbl_data;
	double** h_nlp_distr_and_adj_comb_dbl_ptr;

	int* d_nlp_distr_and_adj_comb_int_data;
	double* d_nlp_distr_and_adj_comb_dbl_data;
	double** d_nlp_distr_and_adj_comb_dbl_ptr;

	int* h_nlp_exp_comb_int_data;
	double** h_nlp_exp_comb_dbl_ptr;

	int* d_nlp_exp_comb_int_data;
	double** d_nlp_exp_comb_dbl_ptr;

	int* h_nlp_mul_comb_no_df_adj_int_data;
	int** h_nlp_mul_comb_no_df_adj_int_ptr;
	double** h_nlp_mul_comb_no_df_adj_dbl_ptr;

	int* d_nlp_mul_comb_no_df_adj_int_data;
	int** d_nlp_mul_comb_no_df_adj_int_ptr;
	double** d_nlp_mul_comb_no_df_adj_dbl_ptr;

	int* h_nlp_compare_mul_sum_int_data;
	int** h_nlp_compare_mul_sum_int_ptr;
	double** h_nlp_compare_mul_sum_dbl_ptr;

	int* d_nlp_compare_mul_sum_int_data;
	int** d_nlp_compare_mul_sum_int_ptr;
	double** d_nlp_compare_mul_sum_dbl_ptr;

	int* h_out_best_case_n;

	double* h_base_coeff;
	double* h_out_best_mul_sum;
	double* h_mul_sum_store;

	int* d_out_best_case_n;

	double* d_base_coeff;
	double* d_work_coeff;
	double* d_work_comb;
	double* d_out_mul_sum;
	double* d_out_best_mul_sum;
};


struct NLP_pnt_jac
{
	int no_prev_mul_sum;
	int found_better_case;

	int issues_n;
	int coeff_cnt;
	int coeff_cnt_plus1;
	int comb_pnt_n;
	int cur_run_start;
	int delay_streams_for_base_coeff;
	int delay_streams_for_base_data;
	int work_rem;
	int cases_base;
	int krnls_issued;
	int cur_stream_ptr;
	int proc_stream_ptr;

	int lmt_iss_res;
	int use_mul_transpose_big;
	int mul_transpose_cases_per_block;
	int use_le_big;

	int cases_per_krnl_offset;
	int coeff_offset;
	int iss_offset;
	int matrix_offset;
	int nlp_distr_and_adj_comb_pnt_blockdim;
	int nlp_distr_and_adj_comb_int_data_offset;
	int nlp_distr_and_adj_comb_dbl_data_offset;
	int nlp_distr_and_adj_comb_dbl_ptr_offset;
	int nlp_exp_comb_int_data_offset;
	int nlp_exp_comb_dbl_ptr_offset;
	int nlp_mul_comb_iss_res_int_data_offset;
	int nlp_mul_comb_iss_res_int_ptr_offset;
	int nlp_mul_comb_iss_res_dbl_ptr_offset;
	int nlp_iss_var_mul_iss_res_int_data_offset;
	int nlp_iss_var_mul_iss_res_dbl_ptr_offset;

	double last_mul_sum;
	double coeff_incr;

	int* h_nlp_distr_and_adj_comb_int_data;
	double* h_nlp_distr_and_adj_comb_dbl_data;
	double** h_nlp_distr_and_adj_comb_dbl_ptr;

	int* d_nlp_distr_and_adj_comb_int_data;
	double* d_nlp_distr_and_adj_comb_dbl_data;
	double** d_nlp_distr_and_adj_comb_dbl_ptr;

	int* h_nlp_exp_comb_int_data;
	double** h_nlp_exp_comb_dbl_ptr;

	int* d_nlp_exp_comb_int_data;
	double** d_nlp_exp_comb_dbl_ptr;

	int* h_nlp_iss_var_lmt_iss_res_int_data;
	double* h_nlp_iss_var_lmt_iss_res_dbl_data;
	double** h_nlp_iss_var_lmt_iss_res_dbl_ptr;

	int* d_nlp_iss_var_lmt_iss_res_int_data;
	double* d_nlp_iss_var_lmt_iss_res_dbl_data;
	double** d_nlp_iss_var_lmt_iss_res_dbl_ptr;

	int* h_nlp_mul_comb_iss_res_int_data;
	int** h_nlp_mul_comb_iss_res_int_ptr;
	double** h_nlp_mul_comb_iss_res_dbl_ptr;

	int* d_nlp_mul_comb_iss_res_int_data;
	int** d_nlp_mul_comb_iss_res_int_ptr;
	double** d_nlp_mul_comb_iss_res_dbl_ptr;

	int* h_nlp_iss_var_mul_iss_res_int_data;
	double** h_nlp_iss_var_mul_iss_res_dbl_ptr;

	int* d_nlp_iss_var_mul_iss_res_int_data;
	double** d_nlp_iss_var_mul_iss_res_dbl_ptr;

	int* h_nlp_matrix_mul_transpose_int_data;
	double** h_nlp_matrix_mul_transpose_dbl_ptr;

	int* d_nlp_matrix_mul_transpose_int_data;
	double** d_nlp_matrix_mul_transpose_dbl_ptr;

	int* h_nlp_matrix_mul_transpose_big_int_data;
	double** h_nlp_matrix_mul_transpose_big_dbl_ptr;

	int* d_nlp_matrix_mul_transpose_big_int_data;
	double** d_nlp_matrix_mul_transpose_big_dbl_ptr;

	int* h_nlp_linear_eq_int_data;
	double** h_nlp_linear_eq_dbl_ptr;

	int* d_nlp_linear_eq_int_data;
	double** d_nlp_linear_eq_dbl_ptr;

	int* h_nlp_linear_eq_big_int_data;
	double** h_nlp_linear_eq_big_dbl_ptr;

	int* d_nlp_linear_eq_big_int_data;
	double** d_nlp_linear_eq_big_dbl_ptr;

	int* h_init_krnl;

	double* h_base_coeff;
	double* h_out_mul_sum;
	double* h_le_out_status;
	double* h_le_out_arr;
	double* h_mul_sum_store;

	double* d_base_coeff;
	double* d_work_comb;
	double* d_base_iss_mul_sum;
	double* d_out_mul_sum;
	double* d_out_iss_mul_sum;
	double* d_base_iss_res;
	double* d_out_iss_res;

	double* d_coeff_delta;
	double* d_jac_matrix;
	double* d_le_matrix;
	double* d_le_out_status;
	double* d_le_out_arr;
	double* d_le_temp_out_arrA;
	double* d_le_temp_out_arrB;
};


#endif
